infixr 9  .
infixr 8  ^, ^^, **
infixl 7  *, /, `quot`, `rem`, `div`, `mod`
infixl 6  +, -

-- The (:) operator is built-in syntax, and cannot legally be given
-- a fixity declaration; but its fixity is given by:
--   infixr 5  :

infix  4  ==, /=, <, <=, >=, >
infixr 3  &&
infixr 2  ||
infixl 1  >>, >>=
infixr 1  =<<
infixr 0  $, $!, `seq`
(==), (/=)          :: (Eq a) => a -> a -> Bool
compare             :: (Ord a) => a -> a -> Ordering
(<), (<=), (>=), (>) :: (Ord a) => a -> a -> Bool
max, min            :: (Ord a) => a -> a -> a
succ, pred          :: (Enum a) => a -> a
toEnum              :: (Enum a) => Int -> a
fromEnum            :: (Enum a) => a -> Int
enumFrom            :: (Enum a) => a -> [a]             -- [n..]
enumFromThen        :: (Enum a) => a -> a -> [a]        -- [n,n'..]
enumFromTo          :: (Enum a) => a -> a -> [a]        -- [n..m]
enumFromThenTo      :: (Enum a) => a -> a -> a -> [a]   -- [n,n'..m]
minBound            :: (Bounded a) => a
maxBound            :: (Bounded a) => a
(+), (-), (*)       :: (Num a) => a -> a -> a
negate              :: (Num a) => a -> a
abs, signum         :: (Num a) => a -> a
fromInteger         :: (Num a) => Integer -> a
toRational          :: (Real a) => a -> Rational
quot, rem           :: (Integral a) => a -> a -> a   
div, mod            :: (Integral a) => a -> a -> a
quotRem, divMod     :: (Integral a) => a -> a -> (a,a)
toInteger           :: (Integral a) => a -> Integer
(/)                 :: (Fractional a) => a -> a -> a
recip               :: (Fractional a) => a -> a
fromRational        :: (Fractional a) => Rational -> a
pi                  :: (Floating a) => a
exp, log, sqrt      :: (Floating a) => a -> a
(**), logBase       :: (Floating a) => a -> a -> a
sin, cos, tan       :: (Floating a) => a -> a
asin, acos, atan    :: (Floating a) => a -> a
sinh, cosh, tanh    :: (Floating a) => a -> a
asinh, acosh, atanh :: (Floating a) => a -> a
properFraction      :: (RealFrac a, Integral b) => a -> (b,a)
truncate, round     :: (RealFrac a, Integral b) => a -> b
ceiling, floor      :: (RealFrac a, Integral b) => a -> b
floatRadix          :: (RealFloat a) => a -> Integer
floatDigits         :: (RealFloat a) => a -> Int
floatRange          :: (RealFloat a) => a -> (Int,Int)
decodeFloat         :: (RealFloat a) => a -> (Integer,Int)
encodeFloat         :: (RealFloat a) => Integer -> Int -> a
exponent            :: (RealFloat a) => a -> Int
significand         :: (RealFloat a) => a -> a
scaleFloat          :: (RealFloat a) => Int -> a -> a
isNaN, isInfinite, isDenormalized, isNegativeZero, isIEEE :: (RealFloat a) => a -> Bool
atan2               :: (RealFloat a) => a -> a -> a
subtract            :: (Num a) => a -> a -> a
even, odd           :: (Integral a) => a -> Bool
gcd                 :: (Integral a) => a -> a -> a
lcm                 :: (Integral a) => a -> a -> a
(^)                 :: (Num a, Integral b) => a -> b -> a
(^^)                :: (Fractional a, Integral b) => a -> b -> a
fromIntegral        :: (Integral a, Num b) => a -> b
realToFrac          :: (Real a, Fractional b) => a -> b
fmap                :: Functor f => (a -> b) -> f a -> f b
(>>=)               :: Monad m => m a -> (a -> m b) -> m b
(>>)                :: Monad m => m a -> m b -> m b
return              :: Monad m => a -> m a
fail                :: Monad m => String -> m a
sequence            :: Monad m => [m a] -> m [a]
sequence_           :: Monad m => [m a] -> m ()
mapM                :: Monad m => (a -> m b) -> [a] -> m [b]
mapM_               :: Monad m => (a -> m b) -> [a] -> m ()
(=<<)               :: Monad m => (a -> m b) -> m a -> m b
id                  :: a -> a
const               :: a -> b -> a
(.)                 :: (b -> c) -> (a -> b) -> a -> c
flip                :: (a -> b -> c) -> b -> a -> c
seq                 :: a -> b -> b
($), ($!)           :: (a -> b) -> a -> b
(&&), (||)          :: Bool -> Bool -> Bool
not                 :: Bool -> Bool
otherwise           :: Bool
maybe               :: b -> (a -> b) -> Maybe a -> b
either              :: (a -> c) -> (b -> c) -> Either a b -> c
numericEnumFrom     :: (Fractional a) => a -> [a]
numericEnumFromThen :: (Fractional a) => a -> a -> [a]
numericEnumFromTo   :: (Fractional a, Ord a) => a -> a -> [a]
numericEnumFromThenTo   :: (Fractional a, Ord a) => a -> a -> a -> [a]
fst                 :: (a,b) -> a
snd                 :: (a,b) -> b
curry               :: ((a, b) -> c) -> a -> b -> c
uncurry             :: (a -> b -> c) -> ((a, b) -> c)
until               :: (a -> Bool) -> (a -> a) -> a -> a
asTypeOf            :: a -> a -> a
error               :: String -> a
undefined           :: a
